// ̧قDoxygenpɏĂ܂B
/*! \file ********************************************************************
*
* Atmel Corporation
*
* \li ̧			: spi_via_usi_driver.c
* \li ߲		: IAR EWAAVR 3.10c
* \li xҰ		: avr@atmel.com
*
* \li x޲	: pr̪(USI)\͂gp\ȑS޲
*					  ATmega169pɏĂ܂B
*
* \li pLq		: AVR319 - SPIʐMɑ΂USI̎g
*
* \li 			: SPIKuƂ̒ʐMpUSIgp@̗B
*					  ړ'spiX_'̊֐ƕϐ͓l̖O(قȂ̪
*					  gp)eSPIײނgpł悤ɉ邱Ƃ
*					  ܂B̊{ISPI̒m̂Ƃ...B
*
*                         $Revision: 1.4 $
*                         $Date: Monday, September 13, 2004 12:08:54 UTC $
****************************************************************************/
#include <ioavr.h>
#include <inavr.h>

//	* USI߰Ăݒ` *

#define USI_OUT_REG		PORTE	//!< USI߰ďoڼ޽
#define USI_IN_REG		PINE	//!< USI߰ēڼ޽
#define USI_DIR_REG		DDRE	//!< USI߰ĕڼ޽
#define USI_CLOCK_PIN	PE4		//!< USIۯo
#define USI_DATAIN_PIN	PE5		//!< USIް
#define USI_DATAOUT_PIN	PE6		//!< USIްo

/*  xݒ:
 *  ޯđx(bps) = CPUSPEEDPRESCALER(COMPAREVALUE+1)2
 *  ő呬x = CPUSPEED64
 */
#define TC0_PRESCALER_VALUE 256	//!< T/C0OuW:1,8,64,256,1024̂ǂꂩłȂ΂Ȃ܂B
#define TC0_COMPARE_VALUE   1	//!< T/C0rl:0`255łȂ΂Ȃ܂(Ou=1ōŏ31)B

// ( OuWΉޯĎwl )

#if TC0_PRESCALER_VALUE == 1
	#define TC0_PS_SETTING (1<<CS00)
#elif TC0_PRESCALER_VALUE == 8
	#define TC0_PS_SETTING (1<<CS01)
#elif TC0_PRESCALER_VALUE == 64
	#define TC0_PS_SETTING (1<<CS01)|(1<<CS00)
#elif TC0_PRESCALER_VALUE == 256
	#define TC0_PS_SETTING (1<<CS02)
#elif TC0_PRESCALER_VALUE == 1024
	#define TC0_PS_SETTING (1<<CS02)|(1<<CS00)
#else
	#error T/C0OuݒłB
#endif

/*! \brief Mް ޯ̧
 *
 * ė޲Ă͎̓]܂ł޲ĂɊi[܂B޲Ă͖{
 * SPISPIް ڼ޽Ɠ悤Ɏgp邱ƂłAĂ͎
 * ̓]Č݂̒l㏑OɁA޲Ăǂ܂Ȃ΂ȂȂ
 * ƂӖ܂B
 */
unsigned char storedUSIDR;

/*! \brief ײޏ׸ލ\
 *
 * ̍\̂ײނɊւ׸ނ܂݂܂B׸ނ͖{SPȈ׸
 * ɑΉ铯Ӗ܂B׸ނ͎gp҂ɂĕύXׂł͂
 * Bײނ͕KvȎ׸ނ̍XVs܂B
 */
struct usidriverStatus_t {
  unsigned char masterMode : 1;			//!< 呕ȕꍇɐ^
  unsigned char transferComplete : 1;	//!< ]ɐ^
  unsigned char writeCollision : 1;		//!< ]ɏo݂͂ꍇɐ^
};

volatile struct usidriverStatus_t spiX_status;	//!< ײޏ׸

/*! \brief /0rv荞ݏ
 *
 * ̊荞ݏ͎呕uް]鎞ɂ܂BUSIۯ 
 * ݂̌ݐ؂ւAƁA2̊荞݂͸ۯ ݏUSIvɑ΂1
 * ̸ۯɋA܂B
 */
#pragma vector=TIMER0_COMP_vect
__interrupt void timer0comp_handler()
{
  USICR |= (1<<USITC);		// ۯo݌ݐ؂ւ
}

/*! \brief USIvꊄ荞ݏ
 *
 * ͎̏呕ȕꍇT/C0rv荞݂֎~܂BUSIv
 * A޲Ă]Ă܂ĂāAT/C0v~Ȃ΂Ȃ܂B
 * SĂ̓ʂɑ΂USIDR̓ei[A׸ނXV܂B
 */
#pragma vector=USI_OVF_vect
__interrupt void usiovf_handler()
{ // 呕u͍XȂUSIv̸ۯ쓮h߂ɔrv荞݂𒼂ɋ֎~Ȃ΂Ȃ܂B
  if( spiX_status.masterMode == 1 ) {	// 呕uȂA
	TIMSK0 &= ~(1<<OCIE0A);				// /0rvA荞݋֎~
  }
  USISR = (1<<USIOIF);					// USIvꊄ荞ݗv׸މ(0)
  spiX_status.transferComplete = 1;		// ]׸ސݒ(1)
  storedUSIDR = USIDR;					// Mli[ۑ(]Jnł̏㏑h~)
}

/*! \brief SPI呕uƂUSI
 *
 * ̊֐͑SĂݕUSǏ`Ԃݒ肵܂BŏɁA܂͏]u
 * 呕uɕύX鎞ɂ̊֐gpĂBi[ꂽUSIDRl
 * 邱ƂɒӂĂB
 *
 *  \param spi_mode  ]SPI(0܂1łȂ΂Ȃ܂B)
 */
void spiX_initmaster( char spi_mode )
{
  USI_DIR_REG |= (1<<USI_DATAOUT_PIN) | (1<<USI_CLOCK_PIN);		// DO,USCK݂o͐ݒ
  USI_DIR_REG &= ~(1<<USI_DATAIN_PIN);							// DI݂͐ݒ
  USI_OUT_REG |= (1<<USI_DATAIN_PIN);							// DI݂ٱߋ

  USICR = (1<<USIOIE) | (1<<USIWM0) |			// USIvꊄ荞݋,3w
		  (1<<USICS1) | (spi_mode<<USICS0) |	// wSPIʑΉOۯw
		  (1<<USICLK);							// ĳ ۯw(USITCŎs)

  TCCR0A = (1<<WGM01) | TC0_PS_SETTING;			// w葬xΉOu,CTCT/0n
  OCR0A = TC0_COMPARE_VALUE;					// w葬xΉT/C0rlݒ

  spiX_status.masterMode       = 1;				// 呕u/]u׸ނ呕u(1)ɐݒ
  spiX_status.transferComplete = 0;				// ]׸މ(0)
  spiX_status.writeCollision   = 0;				// ㏑׸މ(0)
  storedUSIDR = 0;								// Mlޯ̧
}

/*! \brief SPI]uƂUSI
 *
 * ̊֐͑SĂݕUSǏ`Ԃݒ肵܂BŏɁA܂͎呕u
 * ]uɕύX鎞ɂ̊֐gpĂBi[ꂽUSIDRl
 * 邱ƂɒӂĂB
 *
 *  \param spi_mode  ]SPI(0܂1łȂ΂Ȃ܂B)
 */
void spiX_initslave( char spi_mode )
{
  USI_DIR_REG |= (1<<USI_DATAOUT_PIN);							// DO݂o͐ݒ
  USI_DIR_REG &= ~(1<<USI_DATAIN_PIN) | (1<<USI_CLOCK_PIN);		// DI,USCK݂͐ݒ
  USI_OUT_REG |= (1<<USI_DATAIN_PIN) | (1<<USI_CLOCK_PIN);		// DI,USCK݂ٱߋ

  USICR = (1<<USIOIE) | (1<<USIWM0) |			// USIvꊄ荞݋,3w
	        (1<<USICS1) | (spi_mode<<USICS0);	// wSPIʑΉOۯw

  spiX_status.masterMode       = 0;				// 呕u/]u׸ނ]u(0)ɐݒ
  spiX_status.transferComplete = 0;				// ]׸މ(0)
  spiX_status.writeCollision   = 0;				// ㏑׸މ(0)
  storedUSIDR = 0;								// Mlޯ̧
}

/*! \brief ޲ē]
 *
 * {SPISPDR֏悤ɂ̊֐gpĂB呕uł̂
 * ̊֐Ăяo]JnA]uł͎呕uɂĊJn鎟
 * ]p޲Ă܂B]is̏ꍇÅ֐͏㏑׸ނ
 * 肵ް ڼ޽ς邱ƂȂԂ܂B
 *
 *  \returns  ㏑̏ꍇ0AȂ1
 */
char spiX_put( unsigned char val )
{ // MisAƁAUSIv킪0ȊOŐis
  if( (USISR & 0x0F) != 0 ) {			// USIv큂0ŁA
	spiX_status.writeCollision = 1;		// ㏑׸ސݒ(1)
	return 0;							// ㏑LlƋɕA
  }
  spiX_status.transferComplete = 0;		// ]׸ލď
  spiX_status.writeCollision = 0;		// ㏑׸ލď
  USIDR = val;							// ްUSIDRɐݒ

  if( spiX_status.masterMode == 1 ) {	// 呕uŁA
	TIFR0 |= (1<<OCF0A);				// T/C0rv荞ݗv׸މ(0)
	TIMSK0 |= (1<<OCIE0A);				// T/C0rv荞݋
  }
  return 1;								// ㏑ȂlƋɕA
}

/*! \brief M޲Ēl擾
 *
 * ̊֐͍ŌɊi[USIDRlԂłB]׸ނ͌܂
 * B{SPISPDRڼ޽ǂނ悤ɂ̊֐gpĂB
 */
unsigned char spiX_get()
{
  return storedUSIDR;					// ŏIi[MlƋɕA
}

/*! \brief ]ҋ@
 *
 * ̊֐͓]׸ނݒ(1)܂ő҂܂B{SPI荞ݗv׸
 * ҂悤ɂ̊֐gpĂB
 */
void spiX_wait()
{
  do {} while( spiX_status.transferComplete == 0 );		// ]ҋ@
}
